/*
 Dieses ist ein allgemeines Helfer-Script, das alle wichtigen Addons fuer Seiten liefert.
 Benoetigt: frameCommunicator.js
*/



function SiteHelper () {
 // initialization
 var _this = this;
 if (!window.fapi) throw 'siteHelper benoetigt frameCommunicator.js!';
 this.domLoadListener = new Array();
 if (this.scriptPath == '') {
  var s = document.getElementsByTagName('script');
  SiteHelper.prototype.scriptPath = s[s.length-1].src.substring(0, s[s.length-1].src.lastIndexOf('\/')+1);
 }
 function domLoaded () {
  if (_this.domLoadListener == null) return;
  for (var i = 0; i < _this.domLoadListener.length; i++) _this.domLoadListener[i]();
  _this.domLoadListener = null;
 }
 window.addEventListener('DOMContentLoaded', domLoaded, false);
}

SiteHelper.prototype = {
 // private
 scriptPath : '', // class variable, final
 domLoadListener : null, // initialized as array, reset to null on domLoad
 // public
 _siteIsJSWindow : false, get siteIsJSWindow () { return this._siteIsJSWindow; }, set siteIsJSWindow (v) {
  if (v && this._iframeParent != '') throw 'Site cannot be an JSWindow when having an iframeParent!';
  this._siteIsJSWindow = v;
  if (parent == self && v) window.location.href = absolutePath('..\/..\/index.html', this.scriptPath) + '?' + self.location.href;
 },
 _iframeParent : '', get dynIframeParent () { return this._iframeParent; }, set dynIframeParent (v) {
  if (v != '' && this._siteIsJSWindow) throw 'Site cannot be an JSWindow when having an iframeParent!';
  this._iframeParent = v;
  try { parent.document.getElementById('Subtitle').innerHTML = document.title; } catch (e) { }
  if (parent == self && v != '') window.location.href = absolutePath(v, self.location.href) + '?' + self.location.href;
 },
 _siteHasFlapouts : false, get siteHasFlapouts () { return this._siteHasFlapouts; }, set siteHasFlapouts (v) { this._siteHasFlapouts = v; if (v) this.domload(this.flapOut); },
 _siteHasHTMLShow : false, get siteHasHTMLShow () { return this._siteHasHTMLShow; }, set siteHasHTMLShow (v) { this._siteHasHTMLShow = v; if (v) this.domload(this.showHTML); },
 
 domload : /* private */ function (fkt) {
  if (this.domLoadListener == null) fkt();
  else this.domLoadListener.push(fkt);
 },
 showHTML : /* private */ function () {
  function frameSource (f, t) {
   if (!Rainbow) { window.setTimeout(frameSource, 100, f, t); return; }
   f.addEventListener('load', function () { try { Rainbow.color(f.contentWindow.document.getElementsByTagName('html')[0].outerHTML, 'html', function (c) { t.innerHTML = c; }); } catch (e) { } }, false);
   try { Rainbow.color(f.contentWindow.document.getElementsByTagName('html')[0].outerHTML, 'html', function (c) { t.innerHTML = c; }); } catch (e) { }
  }
  var el = document.getElementsByTagName('pre');
  for (var i = 0; i < el.length; i++) {
   if ((' '+el[i].className+' ').indexOf(' codeshow ') < 0) continue;
   var p = el[i].parentElement;
   var j = 0;
   while (j < p.childNodes.length) if (p.childNodes[j] == el[i]) break; else j++;
   if (j >= p.childNodes.length) continue;
   while (j-- > 0) if (p.childNodes[j].nodeType == 1) {
    if (p.childNodes[j].tagName.toLowerCase() == 'iframe') frameSource(p.childNodes[j], el[i]);
    else el[i].textContent = p.childNodes[j].outerHTML;
    break;
   }
  }
 },
 flapOut : /* private */ function () {
  function builtFlapOut (li, ul) {
   var arr1 = document.createElement('span');
   arr1.className = 'arrow';
   try { arr1.innerHTML = (window.getComputedStyle(ul).display == 'none')?'&darr;':'&uarr;'; } catch (e) { return; }
   var arr2 = document.createElement('span');
   arr2.className = 'arrow';
   arr2.innerHTML = arr1.innerHTML;
   if (li.getElementsByTagName('b').length != 0) li = li.getElementsByTagName('b')[0];
   li.addEventListener('click', function () { if (window.getComputedStyle(ul).display == 'none') { ul.style.display = 'block'; arr1.innerHTML = '&uarr;'; } else { ul.style.display = 'none'; arr1.innerHTML = '&darr;'; } arr2.innerHTML = arr1.innerHTML; }, false);
   li.style.cursor = 'pointer';
   li.appendChild(arr2);
   li.insertBefore(arr1, li.firstChild);
  }
  var a = document.getElementsByTagName('ul');
  for (var i = 0; i < a.length; i++) {
   if ((' '+a[i].className+' ').indexOf(' flapout ') == -1) continue;
   var j = 0;
   while (j < a[i].parentElement.childNodes.length) if (a[i].parentElement.childNodes[j] == a[i]) break; else j++;
   while (--j >= 0) if (a[i].parentElement.childNodes[j].nodeType == 1 && a[i].parentElement.childNodes[j].tagName.toLowerCase() == 'li') break;
   if (j == -1) continue;
   builtFlapOut(a[i].parentElement.childNodes[j], a[i]);
  }
 }
}

window.siteHelper = new SiteHelper();