new (function () {
 var unitObj = jsw.units['effects'];
 var blurSourceNumber = 1;

 function show (win, duration, onTerminate, reverse) {
  var v = false;
  if (duration) { // start
   if (!window.getComputedStyle) return; // Keinen Effekt fuer alten IE
   var style = window.getComputedStyle(win.el['OuterBox']);
   if (JSWEffect_terminate(win, (win.effect && win.effect['fkt'] == JSWEffect_Blend && !win.effect.onTerminate)?true:false)) return; // Falls aktiv, laufenden Effekt beenden; falls laufender Effekt JSWEffect_Blend ist, nur abbrechen
   win.effect = new Object();
   win.effect['fkt'] = show;
   win.effect['onTerminate'] = onTerminate;
   win.effect['start'] = getTickCount();
   win.effect['stop'] = win.effect['start'] + duration;
   win.effect['reverse'] = reverse;
   win.effect['interval'] = window.setInterval(win.effect['fkt'], 20, win);
   v = true;
  }
  var t = getTickCount();
  if (isNaN(win.effect['stop']) || t >= win.effect['stop']) { // stop
   if (win.effect['interval']) window.clearInterval(win.effect['interval']);
   win.effect['interval'] = null;
   if (win.effect['reverse']) win.el['OuterBox'].style.visibility = 'hidden';
   win.el['OuterBox'].style.opacity = 1;
   win.el['OuterBox'].style.transform = 'none';
   var onTerm = win.effect['onTerminate'];
   win.effect = null;
   if (onTerm) return onTerm(win);
  } else { // effect
   var s = (t - win.effect['start']) / (win.effect['stop'] - win.effect['start']);
   if (win.effect['reverse']) s = 1-s;
   win.el['OuterBox'].style.opacity = s;
   win.el['OuterBox'].style.transform = 'matrix('+(s*s*0.1+0.9)+', 0, 0, '+(s*s*0.1+0.9)+', '+ 0 + ', ' + 0 + ')';
   if (v) win.el['OuterBox'].style.visibility = 'visible';
  }
 }

 function minimize (win, duration, onTerminate, left, top, reverse) {
  if (duration) { // start
   if (JSWEffect_terminate(win)) return; // Falls aktiv, laufenden Effekt beenden
   win.effect = new Object();
   win.effect['fkt'] = minimize;
   win.effect['start'] = getTickCount();
   win.effect['stop'] = win.effect['start'] + duration;
   win.effect['reverse'] = reverse;
   win.effect['onTerminate'] = onTerminate;
   var p = win.getWindowPos();
   win.effect['diffX'] = left - p[0]-win.el['OuterBox'].offsetWidth/2;
   win.effect['diffY'] = top - p[1]-win.el['OuterBox'].offsetHeight/2;
   win.effect['interval'] = window.setInterval(win.effect['fkt'], 20, win);
  }
  var t = getTickCount();
  if (isNaN(win.effect['stop']) || t >= win.effect['stop']) { // stop
   if (win.effect['interval']) window.clearInterval(win.effect['interval']);
   win.effect['interval'] = null;
   win.el['OuterBox'].style.visibility = 'hidden';
   win.el['OuterBox'].style.transform = 'none';
   win.el['OuterBox'].style.opacity = 1;
   if (!win.effect['reverse']) win.el['OuterBox'].style.visibility = 'hidden';
   var onTerm = win.effect['onTerminate'];
   win.effect = null;
   if (onTerm) return onTerm(win);
  } else { // effect
   var s = (t - win.effect['start']) / (win.effect['stop'] - win.effect['start']);
   if (win.effect['reverse']) s = 1-s;
   s = s*s;
   win.el['OuterBox'].style.transform = 'matrix('+((1-s*s)*0.5+(1-s)*0.4+0.1)+', 0, 0, '+((1-s*s)*0.5+(1-s)*0.4+0.1)+', '+(win.effect['diffX']*s) + ', ' + (win.effect['diffY']*s) + ')';
   win.el['OuterBox'].style.opacity = 1-s;
   win.el['OuterBox'].style.visibility = 'visible';
  }
 }

 function onmove (win) {
  win.el['OuterBox'].style.backgroundPosition = win.el['OuterBox'].offsetLeft / 10 + 'px 0px';
 }
 
 this.free = function () {
  for (var key in oldEffects) jsw.mgr.effects[key] = oldEffects[key];
  jsw.mgr.removeEventListener('move', onmove);
  jsw.mgr.taskbar.menubutton.innerHTML = oldMenuButton;
 };
 


 // Menuebutton anpassen
 var oldMenuButton = jsw.mgr.taskbar.menubutton.innerHTML;
 var a = jsw.mgr.taskbar.menubutton.textContent.split('');
 if (a.length >= 4) {
  a[0] = '<SPAN class="JSW MenuButLetter1">'+a[0]+'<\/SPAN>';
  a[1] = '<SPAN class="JSW MenuButLetter2">'+a[1]+'<\/SPAN>';
  a[2] = '<SPAN class="JSW MenuButLetter3">'+a[2]+'<\/SPAN>';
  a[3] = '<SPAN class="JSW MenuButLetter4">'+a[3]+'<\/SPAN>';
 }
 jsw.mgr.taskbar.menubutton.innerHTML = a.join('') + '<DIV class="JSW Light"><\/DIV>';



 // Effekte und Eventlistener setzen
 var oldEffects = clone(jsw.mgr.effects);
 jsw.mgr.addEventListener('move', onmove);
 jsw.mgr.effects['duration'] = 250;
 jsw.mgr.effects['Activate'] = null;
 jsw.mgr.effects['Deactivate'] = null;
 jsw.mgr.effects['Show'] = show;
 jsw.mgr.effects['ShowParams'] = false;
 jsw.mgr.effects['Hide'] = show;
 jsw.mgr.effects['HideParams'] = true;
 jsw.mgr.effects['Maximize'] = null;
 jsw.mgr.effects['Normalize'] = null; 
 jsw.mgr.effects['Minimize'] = minimize;
 jsw.mgr.effects['Unminimize'] = minimize;
 jsw.mgr.effects['UnminimizeParams'] = true;

 // unit loaded
 unitObj.unit = this;
 unitObj.onload();
})();