function setSpecialAtr (el,atr,val) {
 var A = document.createAttribute(atr);
 A.nodeValue = val;
 el.setAttributeNode(A);
}




function ImgBlend (Img1,Img2,_BlendTime) { with (this) {
 // public: if true, the disappearing image is blend out. Nescessary, if images got different sizes
 this.Fade = false;

 this.BlendTime = _BlendTime;
 this.Img = new Array(Img1,Img2);
 this.Current = 0;
 this.Next = 1;
 this.Blending = false;
 this.Time;
 this.Timer = false;
 this.Cleared = false;
 this.Error = false;
 if (!Img1 || !Img2) Error = true;

 var _this = this;
 var onEvent = function (el, event, fkt, param, behavior) { // provides easy eventListeners. el: Element to set the listener; event: string-name of the event(without "on"); fkt: a Function to call if the event occours, fkt is called in the scope of _this; param: any parameter, that is given to fkt; behavior: flags - 1=only the param is given to fkt (otherwise there is also given the element and the event), 2=event is not given to the element
  var f;
  if (behavior & 4) el.href = 'javascript:\/*Eventlistener*\/';
  if (behavior & 1) f = function (ev) {
    if (!ev) ev = window.event;
 	fkt.call(_this,param);
	if (behavior & 2) { if (ev.preventDefault) ev.preventDefault(); return false; }
   }
  else f = function (ev) {
    if (!ev) ev = window.event;
 	fkt.call(_this,this,ev,param);
    if (behavior & 2) { if (ev.preventDefault) ev.preventDefault(); return false; }
   }
  if (window.addEventListener) el.addEventListener(event, f, false);
  else el.attachEvent('on'+event,f);
  return false;
 }

 this.Blend = function () {
  if (Error) return;
  Timer = false;
  Blending = true;
  if (Time == -1) {
   if (Img[Current].src == '' || Cleared) {
    Img[Next].style.visibility = 'hidden';
    Img[Current].style.visibility = 'visible';
    Img[Current].style.opacity = 1;
    Img[Current].src = Img[Next].src;
    Blending = false;
    return;
   }
   if (Img[Next].complete) {
    Time = 0;
    Img[Current].style.zIndex = 1;
    Img[Next].style.opacity = 0;
    Img[Next].style.zIndex = 2;
    Img[Next].style.visibility = 'visible';
   } else { Timer = window.setTimeout(Blend, 10); return; }
  }
  Img[Next].style.opacity = Time / BlendTime;
  if (Fade) Img[Current].style.opacity = 1 - Time / BlendTime;
  Time = Time + 10;
  if (Time >= BlendTime) {
   Img[Next].style.opacity = 1;
   Img[Current].style.visibility = 'hidden';
   if (Current == 0) {
    Current = 1;
    Next = 0;
   } else {
    Current = 0;
    Next = 1;
   }
   Blending = false;
  } else { Timer = window.setTimeout(Blend, 10); }
 }

 // public: shows a new image with blend-effect
 this.SetImg = function (src, noEffect) {
  if (Error) return;
  Img[Next].src = src;
  Time = -1;
  if (noEffect) {
   Img[Next].style.opacity = 1;
   Img[Next].style.visibility = 'visible';
   Img[Current].style.visibility = 'hidden';
   if (Current == 0) {
    Current = 1;
    Next = 0;
   } else {
    Current = 0;
    Next = 1;
   }
  } else if (!Blending) Blend();
  Cleared = false;
 }

 // public: hides both images
 this.Clear = function () {
  if (Error) return;
  if (Timer != false) window.clearTimeout(Timer);
  Timer = false;
  Img[0].style.visibility = 'hidden';
  Img[1].style.visibility = 'hidden';
  if (!Cleared) {
   Img[0].src = '';
   Img[1].src = '';
  }  Current = 0;
  Next = 1;
  Cleared = true;
  Blending = false;
 }

 if (!Error) onEvent(Img1, 'error', this.Clear);
 if (!Error) onEvent(Img2, 'error', this.Clear);

} }





function ImgShow(Img1,Img2,_BlendTime,_Fullscreen) { with (this) {
 this.BlendTime = _BlendTime;
 this.Blend = new ImgBlend(Img1,Img2,_BlendTime);
 Blend.Fade = true;
 this.Fullscreen = _Fullscreen;
 this.srcs = new Array ();
 this.Pos = 0;
 this.Loop = false;
 this.Timer = false;
 this.Playing = false;
 this.ButBack = false;
 this.ButNext = false;
 this.ButPlayPause = false;
 this.ButRepeat = false;
 this.Duration = 6000;
 
 this.setButtonActions = function () {
  if (ButBack) ButBack.onclick = Back;
  if (ButNext) ButNext.onclick = Next;
  if (ButPlayPause) ButPlayPause.onclick = PlayPause;
  if (ButRepeat) ButRepeat.onclick = function () { SetLoop(!Loop) };
 }

 this.Show = function (noEffect) {
  if (Playing) {
   window.clearInterval(Timer);
   Timer = window.setInterval(TimerFkt, Duration);
  }
  if (ButBack != false) if (!Loop && Pos <= 0) ButBack.className = 'Back';
  else ButBack.className = 'Back Enabled';
  if (ButNext != false) if (!Loop && Pos >= srcs.length - 1) ButNext.className = 'Next';
  else ButNext.className = 'Next Enabled';
  if (Pos >= srcs.length || Pos < 0) return;
  Blend.SetImg(srcs[Pos], noEffect);
 }

 this.TimerFkt = function () {
  Playing = false;
  Next();
  Playing = true;
  if (!Loop && Pos >= srcs.length-1) Pause();
 }

 this.Pause = function () {
  if (Timer != false) window.clearInterval(Timer);
  Timer = false;
  Playing = false;
  if (ButPlayPause != false) ButPlayPause.className = 'Play';
 }

 this.Play = function () {
  if (Timer != false) window.clearInterval(Timer);
  Timer = window.setInterval(TimerFkt, Duration);
  Playing = true;
  if (ButPlayPause != false) ButPlayPause.className = 'Play Enabled';
 }

 this.PlayPause = function () {
  if (Playing) Pause();
  else Play();
 }

 this.SetLoop = function (_Loop) {
  Loop = _Loop;
  if (ButRepeat != false) if (Loop) ButRepeat.className = 'Repeat Enabled';
  else ButRepeat.className = 'Repeat';
  if (ButBack != false) if (!Loop && Pos <= 0) ButBack.className = 'Back';
  else ButBack.className = 'Back Enabled';
  if (ButNext != false) if (!Loop && Pos >= srcs.length - 1) ButNext.className = 'Next';
  else ButNext.className = 'Next Enabled';
 }

 this.GoTo = function (nr, noEffect) {
  if (nr >= srcs.length || nr == Pos) return;
  Pos = nr;
  Show(noEffect);
 }

 this.Next = function () {
  var i = Pos;
  Pos++;
  if (Loop) {
   if (Pos >= srcs.length) Pos = 0;
  } else {
   if (Pos >= srcs.length) Pos = i;
  }
  if (Pos != i) Show();
 }

 this.Back = function () {
  var i = Pos;
  Pos--;
  if (Loop) {
   if (Pos < 0) Pos = srcs.length-1;
  } else {
   if (Pos < 0) Pos = 0;
  }
  if (Pos != i) Show();
 }

 this.SetImg = function (_srcs) {
  Blend.Clear;
  srcs = _srcs.split(',');
  Pos = 0;
  if (srcs.length <= 1) {
   if (ButPlayPause != false) ButPlayPause.style.visibility = 'hidden';
   if (ButRepeat != false) ButRepeat.style.visibility = 'hidden';
  } else {
   if (ButPlayPause != false) ButPlayPause.style.visibility = 'visible';
   if (ButRepeat != false) ButRepeat.style.visibility = 'visible';
  }
  Show();
 }

 this.Clear = function () {
  Blend.Clear();
  srcs = new Array ();
  Pos = 0;
  if (ButPlayPause != false) ButPlayPause.style.visibility = 'hidden';
  if (ButRepeat != false) ButRepeat.style.visibility = 'hidden';
  SetLoop(false);
  Pause();
  Show();
 }

} }