jsw.dependencies(jsw.units['components'], new Array('dialogs'), function () {

new (function () {
 var unitObj = jsw.units['components'];

 // initialization
 var componentLibrary = new Object();

 componentLibrary.a = new Object();
 componentLibrary.a.button = function (el) {
  el.style.backgroundColor = 'red';
  el.jswComponent = this;
 }

 unitObj.onUse = function (win) {
  function scanForComponents (el) {
   if ((' '+el.className+' ').indexOf(' jswComponent ') >= 0) autoCreateComponent(el);
   else for (var i = 0; i < el.childNodes.length; i++) if (el.childNodes[i].nodeType == 1) scanForComponents(el.childNodes[i]);
  }
  scanForComponents(win.document.documentElement);
  win.document.documentElement.addEventListener('DOMContentLoaded', function () { scanForComponents(win.document.documentElement); }, false);
 }
 
 function autoCreateComponent (el, param) {
  if (el.jswComponent) return; // component wurde bereits erstellt
  if (!componentLibrary[el.nodeName.toLowerCase()]) return; // kein Element dieses nodeNames ist eine component
  var types = el.className.split(' ');
  var i = 0;
  var f = -1;
  while (i < types.length) {
   if (types[i] == 'jswComponent') { f = i; i = (i+1)%types.length; } // zuerst jswComponent finden
   if (f != -1) {
    if (i == f) return; // ein Durchlauf durch types hat keinen Treffer ergeben
    if (!componentLibrary[el.nodeName.toLowerCase()][types[i]]) { i = (i+1)%types.length; continue; }
    var c = new componentLibrary[el.nodeName.toLowerCase()][types[i]](el, param);
    if (!el.jswComponent) el.jswComponent = c; // falls der Konstruktor der component vergessen hat, sich einzutragen
    break;
   } else i++;
  }
 }

 this.free = function () {
  for (var key in this) if (typeof this[key] == 'object') this[key] = null;
 }

 // unit loaded
 unitObj.unit = this;
 unitObj.onload();
})();

});