function Contextmenu () { with (this) {
 var menuchain = new Array();

 var close = /* private */ function (box) {
  var i = 0;
  while (i < menuchain.length && menuchain[i] != box) i++;
  for (var j = menuchain.length-1; j >= i; j--) { document.body.removeChild(menuchain[j]); menuchain.pop(); }
  if (i == 0) window.removeEventListener('mousedown', leftclick, false);
 }

 var open = /* private */ function (caller, ev, menu) {
  var box = document.createElement('div');
  box.className = 'contextmenu box';
  // in menuchain einordnen
  var nr = 0;
  if (caller) {
   while (nr < menuchain.length && menuchain[nr] != caller.parentElement) nr++;
   if (nr < menuchain.length) nr++;
  }
  if (nr < menuchain.length) close(menuchain[nr]);
  menuchain[nr] = box;
  if (nr == 0) window.addEventListener('mousedown', leftclick, false);
  // Eintraege erzeugen
  for (var i = 0; i < menu.length; i++) {
   var tr = document.createElement('div');
   tr.className = 'contextmenu button';
   if (!menu[i]['isenabled'] || menu[i]['isenabled']()) {
    if (menu[i]['fkt']) {
	 function scope1 () {
	  var o = menu[i]['obj'];
	  var f = menu[i]['fkt'];
	  tr.addEventListener('click', function () { if (o) f.call(o); else f(); close(box); }, false);
	 }
	 scope1();
    } else if (menu[i]['submenu']) {
	 function scope2 () {
	  var _tr = tr;
	  var _menu = menu[i]['submenu'];
	  tr.addEventListener('click', function () { open(_tr, null, _menu); }, false);
	 }
     scope2();
	}
   } else tr.className += ' disabled';
   if (menu[i]['lineafter']) tr.className += ' lineafter';
   // icon
   var td = document.createElement('div');
   td.className = 'contextmenu icon';
   if (menu[i]['iconClass']) td.className += ' '+menu[i]['iconClass'];
   if (menu[i]['iconURL']) td.style.backgroundImage = 'url('+menu[i]['iconURL']+')';
   tr.appendChild(td);
   // text
   td = document.createElement('div');
   td.className = 'contextmenu text';
   td.innerHTML = menu[i]['text'];
   tr.appendChild(td);
   // submenu
   if (menu[i]['submenu']) {
    td = document.createElement('div');
    td.className = 'contextmenu hassubmenu';
    tr.appendChild(td);
   }
   box.appendChild(tr);
  }
  // Anzeigen
  box.style.visibility = 'hidden';
  document.body.appendChild(box);
  var x,y;
  if (ev) { // Position ermitteln
   x = ev.clientX;
   y = ev.clientY;
   if (y + box.offsetHeight > window.innerHeight) y -= box.offsetHeight;
   if (y < 0) y = 0;
   if (x + box.offsetWidth > window.innerWidth) x = Number.NaN;
  } else {
   var p = caller;
   x = caller.parentElement.offsetWidth;
   y = 0;
   while (p) { if (p != caller) x += p.offsetLeft; y += p.offsetTop; p = p.offsetParent; }
   if (x + box.offsetWidth > window.innerWidth) x -= caller.parentElement.offsetWidth + box.offsetWidth;
   if (x < 0) x = 0;
   if (y + box.offsetHeight > window.innerHeight) y = window.innnerHeight - box.offsetHeight;
  }
  if (isNaN(x)) box.style.right = '0px';
  else box.style.left = x + 'px';
  box.style.top = y + 'px';
  box.style.visibility = 'visible';
 }

 var rightclick = /* private */ function (ev) {
  var el = ev.target;
  while (!el.contextmenu) { el = el.parentElement; if (!el) return true; }
  open(null, ev, el.contextmenu);
  ev.preventDefault();
  return false;
 }

 var leftclick = /* private */ function (ev) {
  var el = ev.target;
  while (el) {
   for (var i = 0; i < menuchain.length; i++) if (menuchain[i] == el) return;
   el = el.parentElement;
  }
  close(menuchain[0]);
 }

 window.addEventListener('contextmenu', rightclick, true);
}}

var contextmenu;
function createContextmenu () {
 if (parent != self) try { contextmenu = parent.contextmenu; } catch (e) {}
 if (!contextmenu) contextmenu = new Contextmenu();
}
createContextmenu();