new (function () {
 var unitObj = jsw.units['errorlog'];

 // initialization
 window.addEventListener('error', function (err) {
  var s = err.filename.toLowerCase();
  if (s.indexOf('system\/js\/jsw') == -1 && s.indexOf('system\/js\/modules') == -1) return;
  
  var el = document.createElement('div');
  el.style.zIndex = 16777271;
  el.style.position = 'fixed';
  el.style.top = '0px';
  el.style.left = '0px';
  el.style.right = '0px';
  el.style.bottom = '0px';
  el.style.backgroundColor = '#0A0';
  el.style.color = 'white';
  el.style.fontSize = '14px';
  el.style.fontFamily = 'Lucida Console';
  el.style.padding = '20px';
  document.body.appendChild(el);
  function add (content) { el.innerHTML += '<BR>' + content; }
  
  el.innerHTML = 'In einem Script von JS Windows ist ein Fehler aufgetreten.';
  window.setTimeout(add, 200, 'URL des fehlerhaften Scriptes lautet "' + err.filename + '"');
  window.setTimeout(add, 400, 'Zeile ' + err.lineno + ', Spalte ' + err.colno);
  window.setTimeout(add, 1000, '<BR>'+err.message+'<BR><BR>');
  window.setTimeout(function () {
   var b = document.createElement('button');
   b.innerHTML = 'Seite neuladen';
   b.onclick = function () { window.location.reload(); }
   el.appendChild(b);
   b = document.createElement('button');
   b.innerHTML = 'Fehler ignorieren';
   b.onclick = function () { document.body.removeChild(el); }
   el.appendChild(b);
  }, 2300);
 }, false);
 
 this.free = function () {
  window.onerror = null;
  for (var key in this) if (typeof this[key] == 'object') this[key] = null;
 }
 
 // unit loaded
 unitObj.unit = this;
 unitObj.onload();
})();